## fs-uae 2.4.1+ds

=== Makefile ===
include common.mk
version := $(strip $(shell cat VERSION))
series := $(strip $(shell cat SERIES))

ifeq ($(wildcard libfsemu),)
    libfsemu_dir := "../libfsemu"
else
    libfsemu_dir := "libfsemu"
endif

all: fs-uae fs-uae-device-helper mo

cppflags = -DFSEMU -DFSUAE -D_FILE_OFFSET_BITS=64

ifeq ($(debug), 1)
cppflags += -DDEBUG
endif

# libfsemu_dir = libfsemu
libfsemu-target:
	$(make) -C $(libfsemu_dir) debug=$(debug) devel=$(devel) \
		optimize=$(optimize) android=$(android) sdl=$(sdl)

#ifeq ($(wildcard libfs-capsimage), libfs-capsimage)
#libfs-capsimage_dir = libfs-capsimage
#libfs-capsimage/out/CAPSImg.dll:
#	make -C libfs-capsimage
#libfs-capsimage-target: libfs-capsimage/out/CAPSImg.dll
#else
#libfs-capsimage_dir = ../libfs-capsimage
#libfs-capsimage-target:
#endif

ifeq ($(android), 1)
use_glib := 0
warnings = 
errors = -Werror=implicit-function-declaration -Werror=return-type
cxxflags = $(warnings) $(errors) -Isrc/od-fs -Isrc/od-fs/include \
		-Isrc/include -Igensrc -Isrc \
		-I$(libfsemu_dir)/include \
		-Wno-write-strings -fpermissive

cflags = -std=c99 $(cxxflags)
ldflags =
libs = -L$(libfsemu_dir)/out -lfsemu -lpng -lz

else
use_glib := 1
use_freetype := 1
sdl := 1

ifeq ($(os), macosx)
	sdl = 2
endif

ifeq ($(sdl), 2)
	sdl_config = sdl2-config
	use_sdl = USE_SDL2
else
	sdl_config = sdl-config
	use_sdl = USE_SDL
endif

common_flags = -Isrc/od-fs -Isrc/od-fs/include \
		-Isrc/include -Igensrc -Isrc \
		`pkg-config --cflags glib-2.0 gthread-2.0 libpng` \
		-I$(libfsemu_dir)/include \
		-I$(libfsemu_dir)/src/lua \
		`$(sdl_config) --cflags`
cflags = $(common_flags) -std=c99 $(CFLAGS)
#cxxflags = $(common_flags) -fpermissive $(CXXFLAGS)
cxxflags = $(common_flags) $(CXXFLAGS)
ldflags = $(LDFLAGS)
libs = -L$(libfsemu_dir)/out -lfsemu `$(sdl_config) --libs` \
		`pkg-config --libs libpng` -lz

ifeq ($(devel), 1)
	warnings = -Wno-unused-variable -Wno-unused-function -Wno-write-strings \
			-Wno-unused-but-set-variable
	errors = -Werror=implicit-function-declaration -Werror=return-type
	cflags += $(warnings) $(errors)
	cxxflags += $(warnings) $(errors)
endif

endif

ifeq ($(use_glib), 1)
	libs += `pkg-config --libs glib-2.0 gthread-2.0`
else ifeq ($(android), 1)
else
	libs += -lrt -lpthread
endif

ifeq ($(use_freetype), 1)
	libs += `pkg-config --libs freetype2`
endif

profile_generate := 0
profile_use := 0

ifeq ($(optimize), 1)
	cflags += -O2 -ggdb
	cxxflags += -O2 -ggdb
else ifneq ($(noflags), 1)
	cflags += -O0 -ggdb
	cxxflags += -O0 -ggdb
endif

ifeq ($(profile_generate), 1)
	cflags += -fprofile-generate
	cxxflags += -fprofile-generate
	ldflags += -fprofile-generate
	libs += -lgcov
endif

ifeq ($(profile_use), 1)
	cflags += -fprofile-use
	cxxflags += -fprofile-use
endif

ifeq ($(force_32bit),1)
	cflags += -m32
	cxxflags += -m32
	ldflags += -m32
endif

#uae_warn = -Wno-unused-value -Wno-uninitialized -Wno-sign-compare
#uae_warn += -fpermissive -Wno-unused-function -Wno-format
#uae_warn +=  -Wmissing-braces -Wall -Wno-sign-compare
uae_warn = -Wall -Wno-sign-compare
generate = 0

ifeq ($(os), android)
  cppflags += -DANDROID
  cxxflags += 
  libs += -lGLESv1_CM
else ifeq ($(os), windows)
  cppflags += -DWINDOWS
  cxxflags += -U_WIN32 -UWIN32
  #cxxflags += -D_WIN32 -DWIN32
  libs += -lOpenGL32 -lGLU32 -lgdi32 -lWinmm -lOpenAL32 -lWs2_32 -lWininet

  ifeq ($(devel), 1)
  libs += -mno-windows
  endif


else ifeq ($(os), macosx)
  uname_m := $(shell uname -m)
  ifneq ($(arch),)
  else ifneq ($(findstring i386,$(uname_m)),)
    arch = i386
  else ifneq ($(findstring Power,$(uname_m)),)
    arch = ppc
  else
    arch = x86_64
    # arch = i386
  endif
  cflags += -arch $(arch)
  cxxflags += -arch $(arch)
  ldflags += -arch $(arch) -headerpad_max_install_names
  cppflags += -DMACOSX
  libs += -framework OpenGL -framework Carbon -framework OpenAL -framework IOKit
else ifeq ($(os), kfreebsd)
  cppflags += -DFREEBSD
  libs += -lGL -lGLU -lopenal -ldl -lX11
else ifeq ($(os), freebsd)
  cppflags += -DFREEBSD
  libs += -lGL -lGLU -lopenal -lX11 -lcompat
else ifeq ($(os), openbsd)
  cppflags += -DOPENBSD
  libs += -lGL -lGLU -lopenal -lX11 -lcompat
else
  cppflags += -DLINUX
  ldflags += -Wa,--execstack
  libs += -lGL -lGLU -lopenal -ldl -lX11
  generate = 0
endif

ifneq ($(os), android)
	cppflags += -D$(use_sdl) -DUSE_GLIB -DWITH_LUA
endif

device_helper_objects = obj/fs-uae-device-helper.o

objects = \
obj/fs-uae-config.o \
obj/fs-uae-input.o \
obj/fs-uae-joystick.o \
obj/fs-uae-keyboard.o \
obj/fs-uae-luascript.o \
obj/fs-uae-main.o \
obj/fs-uae-menu.o \
obj/fs-uae-mouse.o \
obj/fs-uae-paths.o \
obj/fs-uae-recording.o \
obj/fs-uae-uae_config.o \
obj/fs-uae-version.o \
obj/fs-uae-video.o

ifeq ($(os), windows)
objects += obj/fs-uae.res
endif

uae_objects = \
obj/gensrc-blitfunc.o \
obj/gensrc-blittable.o \
obj/gensrc-cpudefs.o \
obj/gensrc-cpuemu_0.o \
obj/gensrc-cpuemu_11.o \
obj/gensrc-cpuemu_12.o \
obj/gensrc-cpuemu_20.o \
obj/gensrc-cpuemu_21.o \
obj/gensrc-cpuemu_22.o \
obj/gensrc-cpuemu_31.o \
obj/gensrc-cpustbl.o \
obj/a2091.o \
obj/akiko.o \
obj/amax.o \
obj/ar.o \
obj/arcadia.o \
obj/aros.rom.o \
obj/audio.o \
obj/autoconf.o \
obj/blitter.o \
obj/blkdev.o \
obj/blkdev_cdimage.o \
obj/bsdsocket.o \
obj/calc.o \
obj/cd32_fmv.o \
obj/cdrom.o \
obj/cdtv.o \
obj/cia.o \
obj/cfgfile.o \
obj/consolehook.o \
obj/cpummu.o \
obj/crc32.o \
obj/custom.o \
obj/debug.o \
obj/disk.o \
obj/diskutil.o \
obj/dongle.o \
obj/drawing.o \
obj/driveclick.o \
obj/enforcer.o \
obj/ersatz.o \
obj/events.o \
obj/expansion.o \
obj/fdi2raw.o \
obj/filesys.o \
obj/fpp.o \
obj/fsdb.o \
obj/fsusage.o \
obj/gayle.o \
obj/gfxutil.o \
obj/hardfile.o \
obj/hrtmon.rom.o \
obj/identify.o \
obj/inputdevice.o \
obj/inputrecord.o \
obj/isofs.o \
obj/keybuf.o \
obj/luascript.o \
obj/main.o \
obj/memory.o \
obj/missing.o \
obj/native2amiga.o \
obj/newcpu.o \
obj/ncr_scsi.o \
obj/readcpu.o \
obj/rommgr.o \
obj/savestate.o \
obj/scsi.o \
obj/scsiemul.o \
obj/specialmonitors.o \
obj/statusline.o \
obj/traps.o \
obj/uaeexe.o \
obj/uaelib.o \
obj/uaeresource.o \
obj/uaeserial.o \
obj/zfile.o \
obj/zfile_archive.o \
obj/jit-compemu.o \
obj/jit-compemu_fpp.o \
obj/jit-compemu_support.o \
obj/jit-compstbl.o \
obj/zip-archiver-unzip.o \
obj/dms-archiver-crc_csum.o \
obj/dms-archiver-getbits.o \
obj/dms-archiver-maketbl.o \
obj/dms-archiver-pfile.o \
obj/dms-archiver-tables.o \
obj/dms-archiver-u_deep.o \
obj/dms-archiver-u_heavy.o \
obj/dms-archiver-u_init.o \
obj/dms-archiver-u_medium.o \
obj/dms-archiver-u_quick.o \
obj/dms-archiver-u_rle.o \
obj/od-fs-audio.o \
obj/od-fs-bsdsocket_host.o \
obj/od-fs-blkdev-linux.o \
obj/od-fs-caps.o \
obj/od-fs-cda_play.o \
obj/od-fs-charset.o \
obj/od-fs-clock.o \
obj/od-fs-cdimage_stubs.o \
obj/od-fs-clipboard.o \
obj/od-fs-driveclick.o \
obj/od-fs-filesys_host.o \
obj/od-fs-fsdb_host.o \
obj/od-fs-hardfile_host.o \
obj/od-fs-gui.o \
obj/od-fs-input.o \
obj/od-fs-keymap.o \
obj/od-fs-libamiga.o \
obj/od-fs-logging.o \
obj/od-fs-mman.o \
obj/od-fs-parser.o \
obj/od-fs-random.o \
obj/od-fs-roms.o \
obj/od-fs-picasso96.o \
obj/od-fs-serial_host.o \
obj/od-fs-stubs.o \
obj/od-fs-support.o \
obj/od-fs-util.o \
obj/od-fs-threading.o \
obj/od-fs-uae_host.o \
obj/od-fs-uaemisc.o \
obj/od-fs-version.o \
obj/od-fs-video.o

ifeq ($(generate), 1)

gensrc/genblitter: obj/genblitter.o obj/blitops.o obj/writelog.o
	$(cxx) $(cppflags) $(cxxflags) obj/genblitter.o obj/blitops.o \
			obj/writelog.o -o gensrc/genblitter

gensrc/gencpu: gensrc/cpudefs.cpp obj/gencpu.o obj/readcpu.o obj/missing.o \
		gensrc/cpudefs.cpp
	$(cxx) $(cppflags) $(cxxflags) obj/gencpu.o obj/readcpu.o obj/missing.o \
			gensrc/cpudefs.cpp -o gensrc/gencpu

gensrc/genlinetoscr:
	$(cxx) $(cppflags) $(cxxflags) src/genlinetoscr.cpp -o gensrc/genlinetoscr

gensrc/gencomp: src/jit/gencomp.cpp obj/readcpu.o obj/gen-cpudefs.o obj/missing.o obj/writelog.o
	$(cxx) $(cppflags) $(cxxflags) src/jit/gencomp.cpp obj/readcpu.o obj/gen-cpudefs.o obj/missing.o obj/writelog.o -o gensrc/gencomp

gensrc/linetoscr.cpp: gensrc/genlinetoscr
	gensrc/genlinetoscr > gensrc/linetoscr.cpp

gensrc/blit.h: gensrc/genblitter
	gensrc/genblitter i > gensrc/blit.h

gensrc/blitfunc.cpp: gensrc/genblitter gensrc/blitfunc.h
	gensrc/genblitter f > gensrc/blitfunc.cpp

gensrc/blitfunc.h: gensrc/genblitter
	gensrc/genblitter h > gensrc/blitfunc.h

gensrc/blittable.cpp: gensrc/genblitter gensrc/blitfunc.h
	gensrc/genblitter t > gensrc/blittable.cpp

gensrc/build68k:
	$(cxx) $(cppflags) $(cxxflags) src/build68k.cpp src/writelog.cpp -o gensrc/build68k

gensrc/cpudefs.cpp: gensrc/build68k src/table68k
	./gensrc/build68k < src/table68k > gensrc/cpudefs.cpp
	#python util/fix_tchar.py gensrc/cpudefs.cpp

gensrc/cpuemu_0.cpp: gensrc/gencpu
	cd gensrc && ./gencpu --optimized-flags

gensrc/cpustbl.cpp: gensrc/cpuemu_0.cpp

gensrc/cputbl.h: gensrc/cpuemu_0.cpp

gensrc/cpuemu_11.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_12.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_20.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_21.cpp: gensrc/cpuemu_0.cpp
gensrc/cpuemu_31.cpp: gensrc/cpuemu_0.cpp

endif

# Using GCC optimization level O0 instead of O2 for cpuemu*, since a bug
# was found caused by the optimizer (where basically (1 ^ 0) & (1 ^ 0) was
# evaluated to 0). This fixes Tower of Babel (IPF).

obj/gensrc-cpuemu%.o: gensrc/cpuemu%.cpp
	$(cxx) $(cppflags) $(cxxflags) -O0 -c $< -o $@

obj/gensrc-%.o: gensrc/%.cpp
	$(cxx) $(cppflags) $(cxxflags) -c $< -o $@

obj/%.o: src/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/zip-archiver-%.o: src/archivers/zip/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/dms-archiver-%.o: src/archivers/dms/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/jit-%.o: src/jit/%.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -c $< -o $@

obj/jit-compemu_support.o: src/jit/compemu_support.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -fpermissive -c $< -o $@

obj/bsdsocket.o: src/bsdsocket.cpp
	$(cxx) $(cppflags) $(cxxflags) $(uae_warn) -fpermissive -c $< -o $@

obj/od-fs-%.o: src/od-fs/%.cpp
	$(cxx) $(cppflags) $(cxxflags) -c $< -o $@

obj/uae.a: gensrc/blit.h gensrc/linetoscr.cpp $(uae_objects)
ifeq ($(os), macosx)
	rm -f $@
endif
	$(ar) cru $@ $(uae_objects)
ifeq ($(os), macosx)
	ranlib $@
endif

obj/fs-uae.res: src/fs-uae/fs-uae.rc
	windres $< -O coff -o $@

obj/fs-uae-%.o: src/fs-uae/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

#ifeq ($(os), windows)
#out/CAPSImg.dll:
#	cp $(libfs-capsimage_dir)/out/CAPSImg.dll out/
#run_deps: out/CAPSImg.dll
#else
#run_deps:
#endif

share/locale/%/LC_MESSAGES/fs-uae.mo: po/%.po
	mkdir -p share/locale/$*/LC_MESSAGES
	msgfmt --verbose $< -o $@

catalogs = \
	share/locale/cs/LC_MESSAGES/fs-uae.mo \
	share/locale/da/LC_MESSAGES/fs-uae.mo \
	share/locale/de/LC_MESSAGES/fs-uae.mo \
	share/locale/es/LC_MESSAGES/fs-uae.mo \
	share/locale/fi/LC_MESSAGES/fs-uae.mo \
	share/locale/fr/LC_MESSAGES/fs-uae.mo \
	share/locale/it/LC_MESSAGES/fs-uae.mo \
	share/locale/nb/LC_MESSAGES/fs-uae.mo \
	share/locale/pl/LC_MESSAGES/fs-uae.mo \
	share/locale/pt/LC_MESSAGES/fs-uae.mo \
	share/locale/sr/LC_MESSAGES/fs-uae.mo \
	share/locale/tr/LC_MESSAGES/fs-uae.mo

mo: $(catalogs)

fs-uae: libfsemu-target obj/uae.a $(objects)
	rm -f fs-uae
	$(cxx) $(ldflags) $(objects) obj/uae.a $(libs) -o fs-uae

fs-uae-device-helper: libfsemu-target $(device_helper_objects)
	rm -f fs-uae-device-helper
	$(cxx) $(ldflags) $(device_helper_objects) $(libs) -o fs-uae-device-helper


build_dir := "."
dist_name = fs-uae-$(version)
dist_dir := $(build_dir)/$(dist_name)
# dist_file := $(build_dir)/$(dist_name).tar.gz

distdir-base:
	rm -Rf $(dist_dir)/*
	mkdir -p $(dist_dir)
	# cp -a $(dist_dir_launcher) $(dist_dir)/launcher

	mkdir -p $(dist_dir)/obj
	touch $(dist_dir)/obj/.dummy
	mkdir -p $(dist_dir)/out
	touch $(dist_dir)/out/.dummy
	cp -a INSTALL README COPYING VERSION SERIES ChangeLog $(dist_dir)
	cp -a common.mk targets.mk $(dist_dir)
	# windows.mk macosx.mk debian.mk
	cp -a Makefile fs-uae.spec example.conf $(dist_dir)

=== arcade/Makefile ===
version := $(strip $(shell cat VERSION))
series := $(strip $(shell cat SERIES))
prefix := /usr
build_dir := "."
dist_name = fs-uae-arcade-$(version)
dist_dir := $(build_dir)/$(dist_name)

ifeq ($(wildcard fsbc),)
	fsbc_dir := "../python"
else
	fsbc_dir := "."
endif

ifeq ($(wildcard fsgs),)
	fsgs_dir := "../python"
else
	fsgs_dir := "."
endif

ifeq ($(wildcard fsui),)
	fsui_dir := "../python"
else
	fsui_dir := "."
endif

ifeq ($(wildcard game_center),)
	game_center_dir := "../python"
else
	game_center_dir := "."
endif

ifeq ($(wildcard lhafile),)
	lhafile_dir := "../python-lhafile"
else
	lhafile_dir := "."
endif

ifeq ($(wildcard six),)
	six_dir := "../python"
else
	six_dir := "."
endif

all: mo

share/locale/%/LC_MESSAGES/fs-uae-arcade.mo: po/%.po
	mkdir -p share/locale/$*/LC_MESSAGES
	msgfmt --verbose $< -o $@

catalogs = \


mo: $(catalogs)

install: mo
	mkdir -p $(DESTDIR)$(prefix)/share
	cp -a share/* $(DESTDIR)$(prefix)/share

	mkdir -p $(DESTDIR)$(prefix)/share/doc/fs-uae-arcade
	cp -a README COPYING $(DESTDIR)$(prefix)/share/doc/fs-uae-arcade

dist_dir := fs-uae-arcade-$(version)

distdir:
	rm -Rf $(dist_dir)/*
	mkdir -p $(dist_dir)

	cp -a $(fsbc_dir)/fsbc $(dist_dir)/
	cp -a $(fsgs_dir)/fsgs $(dist_dir)/
	cp -a $(fsui_dir)/fsui $(dist_dir)/
	cp -a $(game_center_dir)/game_center $(dist_dir)/
	cp -a $(lhafile_dir)/lhafile $(dist_dir)/
	cp -a $(six_dir)/six $(dist_dir)/
	cp -a share $(dist_dir)/
	mkdir $(dist_dir)/po/

	find $(dist_dir) -name "*.mo" -delete
	find $(dist_dir) -name "*.pyc" -delete
	find $(dist_dir) -name "*.pyo" -delete
	find $(dist_dir) -name __pycache__ -delete

	cp COPYING $(dist_dir)/
	cp INSTALL $(dist_dir)/
	cp Makefile $(dist_dir)/
	cp README $(dist_dir)/
	cp SERIES $(dist_dir)/
	cp VERSION $(dist_dir)/
	mkdir -p $(dist_dir)/debian
	cp debian/changelog $(dist_dir)/debian
	cp debian/compat $(dist_dir)/debian
	cp debian/control $(dist_dir)/debian
	cp debian/copyright $(dist_dir)/debian
	cp debian/links $(dist_dir)/debian
	cp debian/rules $(dist_dir)/debian
	mkdir -p $(dist_dir)/debian/source
	cp debian/source/format $(dist_dir)/debian/source
	cp fs-uae-arcade $(dist_dir)/
	cp fs-uae-arcade.spec $(dist_dir)/
	mkdir -p $(dist_dir)/icon
	cp icon/fs-uae-arcade.icns $(dist_dir)/icon
	cp icon/fs-uae-arcade.ico $(dist_dir)/icon
	mkdir -p $(dist_dir)/macosx
	cp macosx/Makefile $(dist_dir)/macosx
	cp po-update.py $(dist_dir)/
	cp setup.py $(dist_dir)/
	cp update-version.py $(dist_dir)/
	mkdir -p $(dist_dir)/windows
	cp windows/Makefile $(dist_dir)/windows
	cp windows/replace-icon.py $(dist_dir)/windows
	cd $(dist_dir) && python update-version.py setup.py
	cd $(dist_dir) && python update-version.py debian/changelog
	cd $(dist_dir) && python update-version.py fs-uae-arcade --update-series
	cd $(dist_dir) && python update-version.py fs-uae-arcade.spec

dist: distdir
	find $(dist_dir) -exec touch \{\} \;
	cd "$(build_dir)" && tar zcfv $(dist_name).tar.gz $(dist_name)

windows-dist: distdir
	cd $(dist_dir)/windows && make
	mv $(dist_dir)/fs-uae-arcade_*windows* .
	rm -Rf $(dist_dir)

macosx-dist: distdir
	cd $(dist_dir)/macosx && make
	mv $(dist_dir)/fs-uae-arcade_*macosx* .
	rm -Rf $(dist_dir)

clean-dist:
	rm -Rf build dist fs-uae-arcade-* fs-uae-arcade_*
	rm -Rf debian/fs-uae-arcade*

clean:
	find share -name "*.mo" -delete
	find . -name "*.pyc" -delete

distclean: clean clean-dist

=== launcher/Makefile ===
version := $(strip $(shell cat VERSION))
series := $(strip $(shell cat SERIES))
prefix := /usr
build_dir := "."
dist_name = fs-uae-launcher-$(version)
dist_dir := $(build_dir)/$(dist_name)

ifeq ($(wildcard fs_uae_launcher),)
	fs_uae_launcher_dir := "../python"
else
	fs_uae_launcher_dir := "."
endif

ifeq ($(wildcard fs_uae_workspace),)
	fs_uae_workspace_dir := "../python"
else
	fs_uae_workspace_dir := "."
endif

ifeq ($(wildcard fsbc),)
	fsbc_dir := "../python"
else
	fsbc_dir := "."
endif

ifeq ($(wildcard fsgs),)
	fsgs_dir := "../python"
else
	fsgs_dir := "."
endif

ifeq ($(wildcard fsui),)
	fsui_dir := "../python"
else
	fsui_dir := "."
endif

ifeq ($(wildcard game_center),)
	game_center_dir := "../python"
else
	game_center_dir := "."
endif

ifeq ($(wildcard lhafile),)
	lhafile_dir := "../python-lhafile"
else
	lhafile_dir := "."
endif

ifeq ($(wildcard six),)
	six_dir := "../python"
else
	six_dir := "."
endif

all: mo

share/locale/%/LC_MESSAGES/fs-uae-launcher.mo: po/%.po
	mkdir -p share/locale/$*/LC_MESSAGES
	msgfmt --verbose $< -o $@

catalogs = \
	share/locale/cs/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/da/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/de/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/es/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/fi/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/fr/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/hu/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/it/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/nb/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/pl/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/pt/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/pt_BR/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/ru/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/sr/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/sv/LC_MESSAGES/fs-uae-launcher.mo \
	share/locale/tr/LC_MESSAGES/fs-uae-launcher.mo

mo: $(catalogs)

install: mo
	mkdir -p $(DESTDIR)$(prefix)/share
	cp -a share/* $(DESTDIR)$(prefix)/share

	mkdir -p $(DESTDIR)$(prefix)/share/doc/fs-uae-launcher
	cp -a README COPYING $(DESTDIR)$(prefix)/share/doc/fs-uae-launcher

dist_dir := fs-uae-launcher-$(version)

distdir:
	rm -Rf $(dist_dir)/*
	mkdir -p $(dist_dir)

	cp -a $(fs_uae_launcher_dir)/fs_uae_launcher $(dist_dir)/
	cp -a $(fs_uae_workspace_dir)/fs_uae_workspace $(dist_dir)/
	cp -a $(fsbc_dir)/fsbc $(dist_dir)/
	cp -a $(fsgs_dir)/fsgs $(dist_dir)/
	cp -a $(fsui_dir)/fsui $(dist_dir)/
	cp -a $(game_center_dir)/game_center $(dist_dir)/
	cp -a $(lhafile_dir)/lhafile $(dist_dir)/
	cp -a $(six_dir)/six $(dist_dir)/
	cp -a share $(dist_dir)/
	mkdir $(dist_dir)/po/

	find $(dist_dir) -name "*.mo" -delete
	find $(dist_dir) -name "*.pyc" -delete
	find $(dist_dir) -name "*.pyo" -delete
	find $(dist_dir) -name __pycache__ -delete

	cp COPYING $(dist_dir)/
	cp INSTALL $(dist_dir)/
	cp Makefile $(dist_dir)/
	cp README $(dist_dir)/
	cp SERIES $(dist_dir)/
	cp VERSION $(dist_dir)/
	mkdir -p $(dist_dir)/debian
	cp debian/changelog $(dist_dir)/debian
	cp debian/compat $(dist_dir)/debian
	cp debian/control $(dist_dir)/debian
	cp debian/copyright $(dist_dir)/debian
	cp debian/links $(dist_dir)/debian
	cp debian/rules $(dist_dir)/debian
	mkdir -p $(dist_dir)/debian/source
	cp debian/source/format $(dist_dir)/debian/source
	cp fs-uae-launcher $(dist_dir)/
	cp fs-uae-launcher.spec $(dist_dir)/
	mkdir -p $(dist_dir)/icon
	cp icon/fs-uae-launcher.icns $(dist_dir)/icon
	cp icon/fs-uae-launcher.ico $(dist_dir)/icon
	mkdir -p $(dist_dir)/macosx
	cp macosx/Makefile $(dist_dir)/macosx
	cp po-update.py $(dist_dir)/
	mkdir -p $(dist_dir)/po
	cp po/cs.po $(dist_dir)/po
	cp po/da.po $(dist_dir)/po
	cp po/de.po $(dist_dir)/po
	cp po/es.po $(dist_dir)/po
	cp po/fi.po $(dist_dir)/po
	cp po/fr.po $(dist_dir)/po
	cp po/hu.po $(dist_dir)/po
	cp po/it.po $(dist_dir)/po
	cp po/nb.po $(dist_dir)/po
	cp po/pl.po $(dist_dir)/po
	cp po/pt.po $(dist_dir)/po
	cp po/pt_BR.po $(dist_dir)/po
	cp po/ru.po $(dist_dir)/po
	cp po/sr.po $(dist_dir)/po
	cp po/sv.po $(dist_dir)/po
	cp po/tr.po $(dist_dir)/po
	cp setup.py $(dist_dir)/
	cp update-version.py $(dist_dir)/
	mkdir -p $(dist_dir)/windows
	cp windows/Makefile $(dist_dir)/windows
	cp windows/fs-uae-launcher.iss $(dist_dir)/windows
	cp windows/replace-icon.py $(dist_dir)/windows
	cd $(dist_dir) && python update-version.py setup.py
	cd $(dist_dir) && python update-version.py debian/changelog
	cd $(dist_dir) && python update-version.py fs-uae-launcher --update-series
	cd $(dist_dir) && python update-version.py fs-uae-launcher.spec

dist: distdir
	find $(dist_dir) -exec touch \{\} \;
	cd "$(build_dir)" && tar zcfv $(dist_name).tar.gz $(dist_name)

windows-dist: distdir
	cd $(dist_dir)/windows && make
	mv $(dist_dir)/fs-uae-launcher_*windows* .
	rm -Rf $(dist_dir)

macosx-dist: distdir
	cd $(dist_dir)/macosx && make
	mv $(dist_dir)/fs-uae-launcher_*macosx* .
	rm -Rf $(dist_dir)

clean-dist:
	rm -Rf build dist fs-uae-launcher-* fs-uae-launcher_*
	rm -Rf debian/fs-uae-launcher*

clean:
	find share -name "*.mo" -delete
	find . -name "*.pyc" -delete

distclean: clean clean-dist

=== libfsemu/Makefile ===
uname := $(shell uname -a)
ifneq ($(findstring Msys,$(uname)),)
    os = windows
else ifneq ($(findstring Darwin,$(uname)),)
    os = macosx
else ifneq ($(findstring FreeBSD,$(uname)),)
    os = freebsd
else ifneq ($(findstring OpenBSD,$(uname)),)
    os = openbsd
else
    os = linux
endif

android := 0

ifeq ($(android), 1)
	os = android
	cc = arm-linux-androideabi-gcc
	cxx = arm-linux-androideabi-g++
	ar = arm-linux-androideabi-ar
else ifeq ($(os), windows)
	cc = gcc
	cxx = g++
	ar = ar
else ifeq ($(os), macosx)
	cc = gcc
	cxx = g++
	ar = ar
else
	cc = $(CC)
	cxx = $(CXX)
	ar = $(AR)
endif

arch :=
debug := 0
noflags := 0
sdl := 1

ifeq ($(sdl), 2)
	sdl_config = sdl2-config
	use_sdl = USE_SDL2
else
	sdl_config = sdl-config
	use_sdl = USE_SDL
endif

cppflags = $(CXXFLAGS)
cflags = -std=c99 -Iinclude -Isrc/lua `$(sdl_config) --cflags` \
		`pkg-config --cflags glib-2.0 gthread-2.0 libpng` \
		`pkg-config --cflags freetype2` \
		$(CFLAGS) -D_FILE_OFFSET_BITS=64
objects = obj/emu_emu.o obj/emu_video.o obj/emu_audio_openal.o \
		obj/emu_audio_common.o obj/emu_audio_dummy.o obj/emu_audio_sdl.o \
		obj/emu_audio_debug.o obj/emu_input.o \
		obj/emu_menu.o obj/emu_texture.o obj/emu_font.o \
		obj/emu_render.o obj/emu_dialog.o obj/emu_hud.o obj/emu_actions.o \
		obj/emu_xml_shader.o obj/emu_util.o obj/emu_netplay.o \
		obj/emu_scanlines.o obj/emu_theme.o obj/emu_video_buffer.o \
		obj/emu_video_options.o obj/emu_audio_dummy.o \
		obj/emu_emu_lua.o \
		\
		obj/ml_ml.o obj/ml_clock.o obj/ml_windows.o obj/ml_render.o \
		obj/ml_sdl.o obj/ml_rawinput.o obj/ml_macosx.o obj/ml_x11.o \
		obj/ml_config.o obj/ml_video.o obj/ml_opengl.o \
		obj/ml_video.o obj/ml_video_mode.o obj/ml_video_sync.o \
		obj/ml_input.o obj/ml_mouse.o obj/ml_keyboard.o \
		\
		obj/mm_linux_evdev.o obj/mm_macosx_hidmanager.o \
		obj/mm_macosx_hidutilities.o obj/mm_manymouse.o \
		obj/mm_windows_wminput.o obj/mm_x11_xinput2.o \
		\
		obj/base.o obj/log.o obj/config.o obj/image.o obj/ref.o \
		obj/glee.o obj/opengl.o obj/thread.o obj/string.o obj/filesys.o \
		obj/unicode.o obj/init.o obj/random.o obj/list.o obj/eventlog.o \
		obj/queue.o obj/hashtable.o obj/inifile.o obj/time.o \
		\
		obj/lua_lapi.o \
		obj/lua_lauxlib.o \
		obj/lua_lbaselib.o \
		obj/lua_lbitlib.o \
		obj/lua_lcode.o \
		obj/lua_lcorolib.o \
		obj/lua_lctype.o \
		obj/lua_ldblib.o \
		obj/lua_ldebug.o \
		obj/lua_ldo.o \
		obj/lua_ldump.o \
		obj/lua_lfunc.o \
		obj/lua_lgc.o \
		obj/lua_linit.o \
		obj/lua_liolib.o \
		obj/lua_llex.o \
		obj/lua_lmathlib.o \
		obj/lua_lmem.o \
		obj/lua_loadlib.o \
		obj/lua_lobject.o \
		obj/lua_lopcodes.o \
		obj/lua_loslib.o \
		obj/lua_lparser.o \
		obj/lua_lstate.o \
		obj/lua_lstring.o \
		obj/lua_lstrlib.o \
		obj/lua_ltable.o \
		obj/lua_ltablib.o \
		obj/lua_ltm.o \
		obj/lua_lundump.o \
		obj/lua_lvm.o \
		obj/lua_lzio.o

ldflags = $(LDFLAGS)
libs =
ifeq ($(force_32bit),1)
    cflags += -m32
    ldflags += -m32
endif

ifeq ($(devel), 1)
	cflags += -Wall -Wno-deprecated-declarations
	cflags += -Werror -Wno-error=unused-function
	#-Werror=implicit-function-declaration
endif

ifeq ($(debug), 1)
	cflags += -g -O0 -fno-inline
else ifneq ($(noflags), 1)
	cflags += -g -O2
endif

ifeq ($(os), windows)
	cppflags += -DWINDOWS -DWIN32
	cppflags += -D$(use_sdl)
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	#cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a

else ifeq ($(android), 1)
	cppflags += -DANDROID
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_GLES
	cppflags += -DUSE_PTHREADS
	library = libfsemu.a

else ifeq ($(os), macosx)
	uname_m := $(shell uname -m)
	ifneq ($(arch),)
	else ifneq ($(findstring i386,$(uname_m)),)
	arch = i386
	else ifneq ($(findstring Power,$(uname_m)),)
	arch = ppc
	else
	arch = x86_64
	# arch = i386
	endif
	cflags += -arch $(arch)
	cxxflags += -arch $(arch)
	ldflags += -arch $(arch)
	cppflags += -DMACOSX
	cppflags += -I/System/Library/Frameworks/OpenAL.framework/Headers
	cppflags += -D$(use_sdl)
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a

else
	ifeq ($(os), linux)
		cppflags += -DLINUX
	else ifeq ($(os), freebsd)
		cppflags += -DFREEBSD
	else ifeq ($(os), openbsd)
		cppflags += -DOPENBSD
	endif
	cppflags += -D$(use_sdl)
	cppflags += -DUSE_PNG
	cppflags += -DUSE_GLIB
	cppflags += -DUSE_X11
	cppflags += -DUSE_SDL_VIDEO
	cppflags += -DUSE_OPENGL
	cppflags += -DUSE_SDL_INPUT
	cppflags += -DUSE_OPENAL
	cppflags += -DUSE_FREETYPE
	library = libfsemu.a
	shared = libfsemu.so.1.0
	shared_soname = libfsemu.so.1
	shared_linkname = libfsemu.so
	shared_ldflags += -shared -Wl,--as-needed -Wl,-soname=$(library_soname)

endif

ifeq ($(os), android)
else
	cppflags += -DWITH_NETPLAY -DWITH_XML_SHADER -DWITH_LUA
	#cppflags += -DWITH_NETPLAY -DUSE_GLES -DFAKE_GLES
endif

all: libfsemu

libfsemu: out/$(library)

obj/%.o: src/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/emu_%.o: src/emu/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/ml_%.o: src/ml/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/mm_%.o: src/ml/manymouse/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

obj/lua_%.o: src/lua/%.c
	$(cc) $(cppflags) $(cflags) -c $< -o $@

out/$(library): $(objects)
ifeq ($(os), macosx)
	rm -f $@
endif
	$(ar) cru $@ $(objects)
ifeq ($(os), macosx)
	ranlib $@
endif

out/$(shared): $(objects)
	$(cc) $(shared_ldflags) $(objects) $(libs) -o $@

fs-test:
	make -C test

prefix := /usr

install:
	mkdir -p $(DESTDIR)$(prefix)/include
	cp -a include/* $(DESTDIR)$(prefix)/include/
	mkdir -p $(DESTDIR)$(prefix)/lib
	cp -a out/$(shared) $(DESTDIR)$(prefix)/lib/
	cp -a out/$(library) $(DESTDIR)$(prefix)/lib/
	ln -s $(shared) $(DESTDIR)$(prefix)/lib/$(shared_linkname)
	mkdir -p $(DESTDIR)$(prefix)/lib/pkgconfig/
	cp -a *.pc $(DESTDIR)$(prefix)/lib/pkgconfig/

clean:
	rm -f obj/*.o
	rm -f out/*.a
	rm -f out/*.so*
	#make -C test clean

clean-dist:

distclean: clean clean-dist

=== macosx/Makefile ===
include ../common.mk
version = $(strip $(shell cat ../VERSION))
game_center_app = fs-uae-game-center_$(version)_macosx/FS-UAE Game Center.app
game_center_resources = $(game_center_app)/Contents/Resources

# all: bindist bindist-launcher bindist-game-center bindist-portable bindist-bundles

all: bindist

clean:
	rm -Rf ../macosx/fs-uae*

bindist: bundle
	cd fs-uae_$(version)_macosx && GZIP=-9 tar zcfv ../../fs-uae_$(version)_macosx.tar.gz *

bundle:
	make -C ..
	rm -Rf fs-uae_$(version)_macosx
	mkdir -p fs-uae_$(version)_macosx
	mkdir -p fs-uae_$(version)_macosx/FS-UAE.app/Contents/Frameworks
	mkdir -p fs-uae_$(version)_macosx/FS-UAE.app/Contents/MacOS
	mkdir -p fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources
	cp -pPR template/* fs-uae_$(version)_macosx/FS-UAE.app/
	cp ../fs-uae fs-uae_$(version)_macosx/FS-UAE.app/Contents/MacOS/
	cp ../fs-uae-device-helper fs-uae_$(version)_macosx/FS-UAE.app/Contents/MacOS/
	cp ../../libfs-capsimage.dylib fs-uae_$(version)_macosx/FS-UAE.app/Contents/Frameworks || cp ../libfs-capsimage.dylib fs-uae_$(version)_macosx/FS-UAE.app/Contents/Frameworks
	cp -pPR ../share/* fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources
	strip fs-uae_$(version)_macosx/FS-UAE.app/Contents/MacOS/*
	#strip fs-uae_$(version)_macosx/FS-UAE.app/Contents/Frameworks/*
	cp ../icon/fs-uae.icns fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources/
	cp ../icon/fs-uae-config.icns fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources/
	cp -pPR ../licenses fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources/
	cp ../COPYING fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources/
	cp ../README fs-uae_$(version)_macosx/FS-UAE.app/Contents/Resources/
	cd fs-uae_$(version)_macosx && python ../fs-make-standalone-app.py FS-UAE.app

launcher:
	make -C ../launcher -f Makefile.mk
	rm -Rf fs-uae-launcher_$(version)_macosx	
	mkdir -p fs-uae-launcher_$(version)_macosx
	cd ../launcher && python2.7 setup_py2app.py py2app --iconfile ../icon/fs-uae-launcher.icns
	mv ../launcher/dist/"FS-UAE Launcher.app" fs-uae-launcher_$(version)_macosx/
	cp -pPR ../launcher/share fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app"/Contents/Resources/

	cp -pPR fs-uae_$(version)_macosx/FS-UAE.app fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app"/Contents/Resources/

bindist-launcher: launcher
	cd fs-uae-launcher_$(version)_macosx && GZIP=-9 tar zcfv ../fs-uae-launcher_$(version)_macosx.tar.gz *

game-center:
	make -C ../launcher -f Makefile.mk
	rm -Rf fs-uae-game-center_$(version)_macosx	
	mkdir -p fs-uae-game-center_$(version)_macosx
	cd ../launcher && python2.7 setup_py2app.py --game-center py2app --iconfile ../icon/fs-uae-launcher.icns
	mv ../launcher/dist/"FS-UAE Game Center.app" "$(game_center_app)"

	cp -pPR ../launcher/share "$(game_center_resources)"/
	mkdir -p "$(game_center_resources)"/share/fs-uae-game-center/fengestad.input
	cp -pPR ../launcher/fengestad/input/res "$(game_center_resources)"/share/fs-uae-game-center/fengestad.input
	mkdir -p "$(game_center_resources)"/share/fs-uae-game-center/fengestad.gamecenter
	cp -pPR ../launcher/fengestad/gamecenter/res "$(game_center_resources)"/share/fs-uae-game-center/fengestad.gamecenter

	cp -pPR fs-uae_$(version)_macosx/FS-UAE.app "$(game_center_resources)"/

bindist-game-center: game-center
	cd fs-uae-game-center_$(version)_macosx && GZIP=-9 tar zcfv ../fs-uae-game-center_$(version)_macosx.tar.gz *

portable:
	rm -Rf fs-uae-suite_$(version)_macosx_portable
	mkdir fs-uae-suite_$(version)_macosx_portable
	touch fs-uae-suite_$(version)_macosx_portable/Portable.ini
	mkdir fs-uae-suite_$(version)_macosx_portable/Kickstarts
	mkdir fs-uae-suite_$(version)_macosx_portable/Configurations
	mkdir fs-uae-suite_$(version)_macosx_portable/Floppies
	mkdir fs-uae-suite_$(version)_macosx_portable/CD-ROMs
	mkdir fs-uae-suite_$(version)_macosx_portable/"Hard Drives"
	mkdir fs-uae-suite_$(version)_macosx_portable/Cache
	mkdir fs-uae-suite_$(version)_macosx_portable/Data
	#mkdir fs-uae-suite_$(version)_macosx_portable/Cache/Temp
	mkdir fs-uae-suite_$(version)_macosx_portable/Downloads
	mkdir fs-uae-suite_$(version)_macosx_portable/Themes
	mkdir fs-uae-suite_$(version)_macosx_portable/"Save States"
	cp -pPR fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app" fs-uae-suite_$(version)_macosx_portable/
	cp -pPR "$(game_center_app)" fs-uae-suite_$(version)_macosx_portable/
	#mkdir fs-uae-suite_$(version)_macosx_portable/Programs
	#mkdir fs-uae-suite_$(version)_macosx_portable/Programs/"Mac OS X"
	#cp -pPR fs-uae_$(version)_macosx/FS-UAE.app fs-uae-suite_$(version)_macosx_portable/Programs/"Mac OS X"

bindist-portable: portable
	cd fs-uae-suite_$(version)_macosx_portable && GZIP=-9 tar zcfv ../fs-uae-suite_$(version)_macosx_portable.tar.gz *

bundles:
	rm -Rf fs-uae-suite_$(version)_macosx
	mkdir fs-uae-suite_$(version)_macosx
	cp -pPR fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app" fs-uae-suite_$(version)_macosx/
	cp -pPR "$(game_center_app)" fs-uae-suite_$(version)_macosx/
	#cp -pPR fs-uae_$(version)_macosx/"FS-UAE.app" fs-uae_$(version)_macosx/"FS-UAE Launcher.app"/Contents/Resources/

bindist-bundles: bundles
	cd fs-uae-suite_$(version)_macosx && GZIP=-9 tar zcfv ../fs-uae-suite_$(version)_macosx.tar.gz *

=== windows/Makefile ===
include ../common.mk
version = $(strip $(shell cat ../VERSION))
emulator_dir = fs-uae_$(version)_windows
launcher_dir = fs-uae-launcher_$(version)_windows
gamecenter_dir = fs-uae-game-center_$(version)_windows
portable_dir = fs-uae-suite_$(version)_windows_portable

#all: bindists setups
#bindists: bindist-emulator bindist-launcher bindist-game-center bindist-portable
#setups: setup-launcher setup-game-center setup-suite

all: progdir zipfile setup

clean:
	rm -Rf fs-uae-*_windows*
	rm -Rf fs-uae_*_windows*

#emulator:
progdir:
	rm -Rf $(emulator_dir)
	mkdir $(emulator_dir)

	make -C ..
	cp /mingw/bin/libgcc_s_*.dll $(emulator_dir)
	cp /mingw/bin/libstdc++*.dll $(emulator_dir)

	cp /mingw/bin/intl.dll $(emulator_dir)
	cp /mingw/bin/libpng*.dll $(emulator_dir)
	cp /mingw/bin/*freetype*.dll $(emulator_dir)
	cp /mingw/bin/zlib1.dll $(emulator_dir)
	cp /mingw/bin/libglib-2.0-0.dll $(emulator_dir)
	cp /mingw/bin/libgthread-2.0-0.dll $(emulator_dir)
	cp /mingw/bin/libintl*.dll $(emulator_dir)
	cp /mingw/bin/libiconv*.dll $(emulator_dir)
	cp /mingw/bin/SDL.dll $(emulator_dir)
	cp /mingw/bin/OpenAL32.dll $(emulator_dir)

	#cp /mingw/bin/libwinpthread*.dll $(emulator_dir)
	#cp /fs/bin/libpng*.dll $(emulator_dir)
	#cp /fs/bin/*freetype*.dll $(emulator_dir)
	#cp /fs/bin/zlib1.dll $(emulator_dir)
	#cp /fs/bin/libglib-2.0-0.dll $(emulator_dir)
	#cp /fs/bin/libgthread-2.0-0.dll $(emulator_dir)
	#cp /fs/bin/libintl*.dll $(emulator_dir)
	#cp /fs/bin/libiconv*.dll $(emulator_dir)
	#cp /fs/bin/SDL.dll $(emulator_dir)
	#cp /fs/bin/OpenAL32.dll $(emulator_dir)

	cp -a ../fs-uae.exe $(emulator_dir)/
	cp -a ../fs-uae-device-helper.exe $(emulator_dir)/
	cp -a ../../CAPSImg.dll $(emulator_dir) || cp -a ../CAPSImg.dll $(emulator_dir)
	cp -a ../share $(emulator_dir)/share
	cp -a ../licenses $(emulator_dir)/licenses
	cp -a ../README $(emulator_dir)/README.txt
	cp -a ../COPYING $(emulator_dir)/COPYING.txt
	strip $(emulator_dir)/*.exe
	strip $(emulator_dir)/*.dll
	python /c/signtool.py $(emulator_dir)/*.exe

zipfile:
	cd $(emulator_dir) && zip -9 -r ../../$(emulator_dir).zip *

setup:
	sed s/9.8.7/${version}/g fs-uae.iss > fs-uae.iss.tmp
	iscc fs-uae.iss.tmp
	python /c/signtool.py ../fs-uae_$(version)_windows.exe
	rm fs-uae.iss.tmp

launcher:
	rm -Rf $(launcher_dir)
	#mkdir $(launcher_dir)

	make -C ../launcher -f Makefile.mk
	rm -Rf ../launcher/dist
	cd ../launcher && python setup_py2exe.py py2exe
	#rm -Rf $(launcher_dir)/Launcher
	mv ../launcher/dist $(launcher_dir)

	cp -a ../launcher/share $(launcher_dir)/Share
	mkdir -p $(launcher_dir)/share/fs-uae-launcher/fs_uae_launcher
	cp -pPR ../launcher/fs_uae_launcher/res $(launcher_dir)/share/fs-uae-launcher/fs_uae_launcher/

	mv $(launcher_dir)/fs-uae-launcher.exe $(launcher_dir)/"FS-UAE Launcher.exe"
	python replace_icon.py $(launcher_dir)/"FS-UAE Launcher.exe" ../icon/fs-uae-launcher.ico
	python /c/signtool.py $(launcher_dir)/"FS-UAE Launcher.exe"
	cp -a /mingw/Microsoft.VC90.CRT $(launcher_dir)/
	cp -a $(emulator_dir) $(launcher_dir)/FS-UAE

bindist-launcher: launcher
	cd $(launcher_dir) && zip -9 -r ../$(launcher_dir).zip *

game-center:
	rm -Rf $(gamecenter_dir)
	#mkdir $(gamecenter_dir)

	make -C ../launcher -f Makefile.mk
	rm -Rf ../launcher/dist
	cd ../launcher && python setup_py2exe.py py2exe --game-center
	#rm -Rf $(gamecenter_dir)/"Game Center"
	mv ../launcher/dist $(gamecenter_dir)

	cp -a ../launcher/share $(gamecenter_dir)/Share
	mkdir -p $(gamecenter_dir)/share/fs-uae-game-center/fengestad.input
	cp -pPR ../launcher/fengestad/input/res $(gamecenter_dir)/share/fs-uae-game-center/fengestad.input/
	mkdir -p $(gamecenter_dir)/share/fs-uae-game-center/fs_uae_launcher
	# don't really need all files, just adf save disk and possible some other, these resources
	# should be moved to another package anyway
	cp -pPR ../launcher/fs_uae_launcher/res $(gamecenter_dir)/share/fs-uae-game-center/fs_uae_launcher/
	mkdir -p $(gamecenter_dir)/share/fs-uae-game-center/fengestad.gamecenter
	cp -pPR ../launcher/fengestad/gamecenter/res $(gamecenter_dir)/share/fs-uae-game-center/fengestad.gamecenter

	mv $(gamecenter_dir)/fs-uae-game-center.exe $(gamecenter_dir)/"FS-UAE Game Center.exe"
	python replace_icon.py $(gamecenter_dir)/"FS-UAE Game Center.exe" ../icon/fs-uae-launcher.ico
	python /c/signtool.py $(gamecenter_dir)/"FS-UAE Game Center.exe"
	cp -a /mingw/Microsoft.VC90.CRT $(gamecenter_dir)/
	cp -a $(emulator_dir) $(gamecenter_dir)/FS-UAE

bindist-game-center: game-center
	cd $(gamecenter_dir) && zip -9 -r ../$(gamecenter_dir).zip *

portable:
	rm -Rf $(portable_dir)
	mkdir $(portable_dir)
	touch $(portable_dir)/Portable.ini
	mkdir $(portable_dir)/Kickstarts
	mkdir $(portable_dir)/Configurations
	mkdir $(portable_dir)/Floppies
	mkdir $(portable_dir)/CD-ROMs
	mkdir $(portable_dir)/"Hard Drives"
	mkdir $(portable_dir)/Cache
	mkdir $(portable_dir)/Data
	# mkdir $(portable_dir)/Cache/Temp
	mkdir $(portable_dir)/Downloads
	mkdir $(portable_dir)/Themes
	mkdir $(portable_dir)/"Save States"

	cp launcher-proxy.exe $(portable_dir)/"FS-UAE Launcher.exe"
	python replace_icon.py $(portable_dir)/"FS-UAE Launcher.exe" ../icon/fs-uae-launcher.ico
	python /c/signtool.py $(portable_dir)/"FS-UAE Launcher.exe"

	cp game-center-proxy.exe $(portable_dir)/"FS-UAE Game Center.exe"
	python replace_icon.py $(portable_dir)/"FS-UAE Game Center.exe" ../icon/fs-uae-launcher.ico
	python /c/signtool.py $(portable_dir)/"FS-UAE Game Center.exe"

	# mkdir $(portable_dir)/Programs
	# mkdir $(portable_dir)/Programs/Windows
	mkdir $(portable_dir)/Windows
	# cp -a $(emulator_dir) $(portable_dir)/Programs/Windows/FS-UAE
	cp -a  $(launcher_dir) $(portable_dir)/Windows/"FS-UAE Launcher"
	cp -a  $(gamecenter_dir) $(portable_dir)/Windows/"FS-UAE Game Center"

	# rm -R FS-UAE/Windows/Emulator/launcher

bindist-portable: portable
	cd $(portable_dir) && zip -9 -r ../$(portable_dir).zip *

setup-launcher:
	iscc launcher.iss
	python /c/signtool.py fs-uae-launcher_$(version)_windows.exe

setup-game-center:
	iscc game-center.iss
	python /c/signtool.py fs-uae-game-center_$(version)_windows.exe

setup-suite:
	# iscc suite.iss
	# python /c/signtool.py fs-uae-suite_$(version)_windows.exe

=== arcade/macosx/Makefile ===
version = $(strip $(shell cat ../VERSION))
arcade_app = fs-uae-arcade_$(version)_macosx/FS-UAE Arcade.app
arcade_resources = $(arcade_app)/Contents/Resources

all: bindist-arcade

clean:
	rm -Rf ../macosx/fs-uae*

arcade:
	# make -C ..
	rm -Rf fs-uae-arcade_$(version)_macosx	
	mkdir -p fs-uae-arcade_$(version)_macosx
	cd .. && python2.7 setup.py py2app --iconfile icon/fs-uae-arcade.icns
	mv ../dist/"FS-UAE Arcade.app" "$(arcade_app)"

	cp -pPR ../share "$(arcade_resources)"/
	# mkdir -p "$(arcade_resources)"/share/fs-uae-arcade/fengestad.input
	# cp -pPR ../fengestad/input/res "$(arcade_resources)"/share/fs-uae-arcade/fengestad.input
	# mkdir -p "$(arcade_resources)"/share/fs-uae-arcade/fengestad.gamecenter
	# cp -pPR ../fengestad/gamecenter/res "$(arcade_resources)"/share/fs-uae-arcade/fengestad.gamecenter
	# cp -pPR fs-uae_$(version)_macosx/FS-UAE.app "$(arcade_resources)"/

bindist-arcade: arcade
	cd fs-uae-arcade_$(version)_macosx && GZIP=-9 tar zcfv ../../fs-uae-arcade_$(version)_macosx.tar.gz *

=== arcade/windows/Makefile ===
version = $(strip $(shell cat ../VERSION))
program_dir = fs-uae-arcade_$(version)_windows

all: progdir zipfile setup

clean:
	rm -Rf fs-uae-arcade-*_windows*
	rm -Rf fs-uae-arcade_*_windows*

progdir:
	rm -Rf $(program_dir)

	# make -C ..

	rm -Rf ../build ../dist
	cd .. && python setup.py py2exe
	mv ../dist $(program_dir)

	cp -a ../share $(program_dir)/share

	python replace-icon.py $(program_dir)/fs-uae-arcade.exe ../icon/fs-uae-arcade.ico
	python /c/signtool.py $(program_dir)/fs-uae-arcade.exe
	cp -a /c/Microsoft.VC90.CRT $(program_dir)/
	# cp -a $(emulator_dir) $(program_dir)/FS-UAE

zipfile:
	cd $(program_dir) && zip -9 -r ../../$(program_dir).zip *

setup:
	sed s/9.8.7/${version}/g fs-uae-arcade.iss > fs-uae-arcade.iss.tmp
	iscc fs-uae-arcade.iss.tmp
	python /c/signtool.py ../fs-uae-arcade_$(version)_windows.exe
	rm fs-uae-arcade.iss.tmp

=== launcher/macosx/Makefile ===
version = $(strip $(shell cat ../VERSION))

all: bindist-launcher

clean:
	rm -Rf ../macosx/fs-uae-launcher*

launcher:
	make -C ..
	rm -Rf fs-uae-launcher_$(version)_macosx	
	mkdir -p fs-uae-launcher_$(version)_macosx
	cd .. && python2.7 setup.py py2app --iconfile icon/fs-uae-launcher.icns
	mv ../dist/"FS-UAE Launcher.app" fs-uae-launcher_$(version)_macosx/
	cp -pPR ../share fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app"/Contents/Resources/

	# cp -pPR fs-uae_$(version)_macosx/FS-UAE.app fs-uae-launcher_$(version)_macosx/"FS-UAE Launcher.app"/Contents/Resources/

bindist-launcher: launcher
	cd fs-uae-launcher_$(version)_macosx && GZIP=-9 tar zcfv ../../fs-uae-launcher_$(version)_macosx.tar.gz *

=== launcher/windows/Makefile ===
version = $(strip $(shell cat ../VERSION))
emulator_dir = fs-uae_$(version)_windows
launcher_dir = fs-uae-launcher_$(version)_windows

all: progdir zipfile setup

clean:
	rm -Rf fs-uae-launcher-*_windows*
	rm -Rf fs-uae-launcher_*_windows*

progdir:
	rm -Rf $(launcher_dir)

	make -C ..

	rm -Rf ../build ../dist
	cd .. && python setup.py py2exe
	mv ../dist $(launcher_dir)

	cp -a ../share $(launcher_dir)/share
	# mkdir -p $(launcher_dir)/share/fs-uae-launcher/fs_uae_launcher
	# cp -pPR ../fs_uae_launcher/res $(launcher_dir)/share/fs-uae-launcher/fs_uae_launcher/
	# cp -pPR ../fs_uae_launcher/data $(launcher_dir)/share/fs-uae-launcher/fs_uae_launcher/
	# mkdir -p $(launcher_dir)/share/fs-uae-launcher/fs_uae_workspace
	# cp -pPR ../fs_uae_workspace/data $(launcher_dir)/share/fs-uae-launcher/fs_uae_workspace/

	python replace-icon.py $(launcher_dir)/fs-uae-launcher.exe ../icon/fs-uae-launcher.ico
	python /c/signtool.py $(launcher_dir)/fs-uae-launcher.exe
	cp -a /c/Microsoft.VC90.CRT $(launcher_dir)/
	# cp -a $(emulator_dir) $(launcher_dir)/FS-UAE

zipfile:
	cd $(launcher_dir) && zip -9 -r ../../$(launcher_dir).zip *

setup:
	sed s/9.8.7/${version}/g fs-uae-launcher.iss > fs-uae-launcher.iss.tmp
	iscc fs-uae-launcher.iss.tmp
	python /c/signtool.py ../fs-uae-launcher_$(version)_windows.exe
	rm fs-uae-launcher.iss.tmp

=== debian/changelog ===
fs-uae (2.4.1+ds-3) unstable; urgency=medium

  * Add debian/patches/0003-remove-custom-mprotect-function.patch
    to fix a segmentation fault when running fs-uae with recent
    versions of the proprietary nVidia driver (Closes: #757164).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 27 Jan 2015 22:38:53 +0100

fs-uae (2.4.1+ds-2) unstable; urgency=medium

  * Add missing dependency on python-pil for fs-uae-arcade in debian/control.
  * Add missing copyright entry in debian/copyright for arcade/* files.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 03 May 2014 19:21:51 +0200

fs-uae (2.4.1+ds-1) unstable; urgency=medium

  * New upstream release. (Closes: #739796)
  * Add binary package entry for fs-uae-arcade in debian/control.
  * Update copyright years in debian/copyright.
  * Add build and install directives for fs-uae-arcade and update build
    and install directives fs-uae-launcher in debian/rules.
  * Add links file for fs-uae-arcade.
  * Drop debian/patches/0003-disable-JIT-on-non-i386.patch, no longer needed.
  * Drop debian/patches/0004-add-generic-maccess.patch, merged upstream.
  * Drop debian/patches/0005-add-kfreebsd-build-support.patch, merged upstream.
  * Refresh debian/patches/0001-use-external-libglee.patch.
  * Refresh debian/patches/0002-dont-copy-upstream-copying-file.patch.
  * Add build dependency for libxi-dev in debian/control.
  * Update debian/README.Debian to include fs-uae-arcade.
  * Update debian/README.source to reflect the changes to the source package.
  * Update dependencies for fs-uae-launcher in debian/control.
  * Update standards version to 3.9.5 in debian/control.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 06 Apr 2014 21:32:52 +0200

=== debian/control ===
Source: fs-uae
Section: otherosfs
Priority: optional
Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Build-Depends: debhelper (>= 9), libsdl1.2-dev, libglib2.0-dev, libopenal-dev, gettext, python (>= 2.6), python-setuptools, glee-dev, libxi-dev
Standards-Version: 3.9.5
Homepage: http://fs-uae.net
Vcs-Git: git://github.com/glaubitz/fs-uae-debian.git
Vcs-Browser: https://github.com/glaubitz/fs-uae-debian

Package: fs-uae
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libfs-capsimage4
Description: Cross-platform Amiga emulator based on UAE/WinUAE
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.

Package: fs-uae-launcher
Architecture: all
Depends: python (>= 2.6), ${misc:Depends}, ${python:Depends}, python-pyside, python-setuptools, fs-uae
Description: Launcher and configuration program for FS-UAE
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.
 .
 This package contains the launcher, a graphical user interface for
 setting up FS-UAE.

Package: fs-uae-netplay-server
Architecture: all
Depends: python (>= 2.6), ${misc:Depends}, adduser (>= 3.11)
Description: Netplay server for FS-UAE online play
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.
 .
 This package contains the FS-UAE netplay game server, and a service
 to start game servers on demand.

Package: fs-uae-arcade
Architecture: all
Depends: python (>= 2.6), ${misc:Depends}, ${python:Depends}, python-pygame, python-numpy, python-opengl, python-pil, python-setuptools, fs-uae
Recommends: python-lhafile, fs-uae-launcher
Description: Fullscreen game browser for FS-UAE
 FS-UAE is a cross-platform Amiga emulator based on updated emulation code
 from WinUAE. FS-UAE uses SDL for input, OpenAL for audio and OpenGL
 for graphics.
 .
 This package contains FS-UAE Arcade, a fullscreen game browser
 for couch potatoes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=arcade
	make -C arcade
	dh_auto_build --sourcedirectory=launcher
	make -C launcher

override_dh_auto_install:
	make install prefix=$$(pwd)/debian/fs-uae/usr
	make -C arcade install prefix=$$(pwd)/debian/fs-uae-arcade/usr
	cd arcade && python setup.py install --no-compile --install-layout=deb --root=../debian/fs-uae-arcade --install-lib=/usr/share/fs-uae-arcade --install-scripts=/usr/share/fs-uae-arcade
	make -C launcher install prefix=$$(pwd)/debian/fs-uae-launcher/usr
	cd launcher && python setup.py install --no-compile --install-layout=deb --root=../debian/fs-uae-launcher --install-lib=/usr/share/fs-uae-launcher --install-scripts=/usr/share/fs-uae-launcher
	cd server && python setup.py install --no-compile --install-layout=deb --root=../debian/fs-uae-netplay-server --install-lib=/usr/share/fs-uae-netplay-server --install-scripts=/usr/share/fs-uae-netplay-server

%:
	dh $@
